<template>
  <div class="qrcode">
    <p>
      <label for="token">Token : </label>
      <input id="token" :value="token" :class="{valid: authenticated, invalid: !authenticated}" type="password" placeholder="Edit your token" @change="updateToken">
      <span v-if="!authenticated">QR codes won't be saved until you don't have a valid</span>
    </p>
    <p v-if="qrcodes">
      <v-list>
        <draggable v-model="qrcodes" group="qrcode">
          <qrcode-tile
            v-for="(qrcode, index) in qrcodes"
            ref="qrcode"
            :key="index"
            :qrcode="qrcode"
            @change="saveQRCodes"
            @remove="deleteQRCode(index)"
          />
        </draggable>
      </v-list>
      <v-btn icon @click="createQRCode"><v-icon>add</v-icon></v-btn>
    </p>
  </div>
</template>

<script>
import { mapActions, mapState } from 'vuex'
import QRCodeTile from '@/components/QRCode-tile.vue'
import draggable from 'vuedraggable'

export default {
  name: "qrcode-list",
  components: {
    draggable,
    'qrcode-tile': QRCodeTile
  },
  computed: {
    ...mapState({
      'authenticated': 'authenticated',
      'token': 'token',
      '_qrcodes': 'qrcodes'
    }),
    'qrcodes': {
      get: function() { return (this._qrcodes) },
      set: function(qrcodes) { this.updateQRCodes(qrcodes) }
    }
  },
  created() {
    this.updateQRCodes([])
    this.updateToken(this.$route.query.token)
  },
  methods: {
    ...mapActions([
      'updateToken',
      'addQRCode',
      'deleteQRCode',
      'saveQRCodes',
      'updateQRCodes'
    ]),
    createQRCode() {
      this.addQRCode()
      setTimeout(() => {
        this.$refs.qrcode.slice(-1)[0].editQRCode()
      }, 100)
    }
  },
}
</script>
<style scoped>
.v-list {
  background: inherit;
  max-width: 100%;
  margin: 5px 10px;
}
.invalid {
  border: 1px solid red;
  background-color: hsl(0, 50%, 90%)
}
</style>
